#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <windows.h>

#include "CIniFile.h"
CIniFile *IniFile;

extern int ToClip(char *Title, int ndata, double *x, double *y[]);

void main(int argn, char *argv[])
{
	FILE *in;
	char szFile[256], szFileTitle[256] = "", InitDir[256] = "";
	char Title[256];
	char *cp;
	char str[256];
	bool debug = 0;

	IniFile = new CIniFile(argv[0]);
	if(argn < 2)
	{
		OPENFILENAME ofn;
		memset(&ofn, 0, sizeof(OPENFILENAME));
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = NULL;
		ofn.lpstrFilter = "Data File (*.*)";
		ofn.nFilterIndex = 1;
		strcpy(szFile, "*.*");
		ofn.lpstrFile = szFile;
		ofn.nMaxFile = sizeof(szFile);
		ofn.lpstrFileTitle = szFileTitle;
		ofn.nMaxFileTitle = sizeof(szFileTitle);
		IniFile->GetString("Preferences", "ReadDir", "", InitDir);
		ofn.lpstrInitialDir = InitDir;
		ofn.Flags = OFN_SHOWHELP;
		ofn.Flags |= OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
		ofn.lpstrTitle = "Data File Read";

		if(GetOpenFileName(&ofn))
		{
		}
		else
		{
			printf("usage: ToClip infile\n\n");
			exit(1);
		}
		strcpy(str, szFile);
		cp = strrchr(str, '\\');
		if(cp != NULL)
		{
			*cp = 0;
			IniFile->WriteString("Preferences", "ReadDir", str);
		}
	}
	else strcpy(szFile, argv[1]);
	strcpy(Title, szFile);
	if((in = fopen(szFile, "r")) == NULL)
	{
		perror(szFile);
		exit(1);
	}
	if(debug) printf("Title: %s\n", Title);

	char *buf;
	buf = new char[1000000];
	sprintf(buf, "%s\r\n", Title);
	char s[256];
	char *src, *dest;
	bool IsValue;
	while(1)
	{
		fgets(str, 256, in);
		if(feof(in)) break;
		IsValue = TRUE;
		for(cp = str ; *cp != 0 ; cp++)
		{
			if(strchr(":/+-0123456789DEde. \t\r\n", *cp) == NULL)
			{
				IsValue = false;
				break;
			}
		}
		if(IsValue)
		{
			src = str;
			while(*src == ' ' || *src == '\t') src++;
			for(dest = s ; *src != 0 ; )
			{
				if(*src == ' ' || *src == '\t')
				{
					*dest = '\t';
					dest++;
					while(*src == ' ' || *src == '\t') src++;
				}
				else if((*src == 'D' || *src == 'd') &&
						 (strchr(".0123456789", *(src-1)) != NULL))
				{
					*dest = 'E';
					dest++;
					src++;
				}
				else
				{
					*dest = *src;
					dest++;
					src++;
				}
			}
			*dest = 0;
		}
		else
			strcpy(s, str);
		cp = strrchr(s, '\n');
		if(cp != NULL) strcpy(cp, "\r\n");
		strcat(buf, s);
	}

	int wLength = strlen(buf);
	int i;
	HGLOBAL hGlobalMemory = GlobalAlloc(GHND, (DWORD)wLength + 1);
	char *lpGlobalMemory = (char *)GlobalLock(hGlobalMemory);
	char *pString = buf;
	for(i = 0 ; i < wLength ; i++)
		*lpGlobalMemory++ = *pString++;
	GlobalUnlock(hGlobalMemory);
	OpenClipboard(NULL);
	EmptyClipboard();
	SetClipboardData(CF_TEXT, hGlobalMemory);
	CloseClipboard();

	fclose(in);
	delete []buf;
	delete IniFile;
}
