// SetupScaleDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SetupScaleDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupScaleDialog _CAO


CSetupScaleDialog::CSetupScaleDialog(CGraphFrameArray *framearray, CWnd* pParent /*=NULL*/)
	: CDialog(CSetupScaleDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetupScaleDialog)
	m_ViewXMax = 0.0;
	m_ViewXMin = 0.0;
	m_ViewYMin = 0.0;
	m_ViewYMax = 0.0;
	m_pGraphFrameArray = framearray;
	m_ReverseYAxis = FALSE;
	m_ReverseXAxis = FALSE;
	//}}AFX_DATA_INIT
}


void CSetupScaleDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupScaleDialog)
	DDX_Text(pDX, IDC_VIEWXMAXEDIT, m_ViewXMax);
	DDX_Text(pDX, IDC_VIEWXMINEDIT, m_ViewXMin);
	DDX_Text(pDX, IDC_VIEWYMINEDIT, m_ViewYMin);
	DDX_Text(pDX, IDC_VIEWYMAXEDIT, m_ViewYMax);
	DDX_Check(pDX, IDC_REVERSEYAXISCHECK, m_ReverseYAxis);
	DDX_Check(pDX, IDC_REVERSEXAXISCHECK, m_ReverseXAxis);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupScaleDialog, CDialog)
	//{{AFX_MSG_MAP(CSetupScaleDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupScaleDialog bZ[W nh

BOOL CSetupScaleDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	CGraphFrame *pFrame = m_pGraphFrameArray->GetGraphFrame(0);
	m_ViewXMin = pFrame->ViewXMin();
	m_ViewXMax = pFrame->ViewXMax();
	m_ViewYMin = pFrame->ViewYMin();
	m_ViewYMax = pFrame->ViewYMax();
	m_ReverseXAxis = pFrame->IsReverseAxisX();
	m_ReverseYAxis = pFrame->IsReverseAxisY();
	UpdateData(FALSE);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CSetupScaleDialog::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	UpdateData(TRUE);
	CGraphFrame *pFrame = m_pGraphFrameArray->GetGraphFrame(0);
	pFrame->SetViewXMin(m_ViewXMin);
	pFrame->SetViewXMax(m_ViewXMax);
	pFrame->SetViewYMin(m_ViewYMin);
	pFrame->SetViewYMax(m_ViewYMax);
	pFrame->SetReverseAxisX(m_ReverseXAxis);
	pFrame->SetReverseAxisY(m_ReverseYAxis);

	CDialog::OnOK();
}
